Object subclass: #Pokemon
	instanceVariableNames: 'nombre puntos ataques'
	classVariableNames: ''
	package: 'Pokemones'!

!Pokemon methodsFor: 'setter' stamp: 'tomas 6/25/2020 13:10'!
nombre: unNombre
	nombre := unNombre.
	nombre = 'Pikachu'
		ifTrue: [
			puntos := 90.
			ataques add: 'ImpacTrueno'
		] ifFalse: [
			puntos := 100.
			nombre = 'Charmander'
				ifTrue: [ ataques add: 'Brasas' ]
		]! !


!Pokemon methodsFor: 'initialization' stamp: 'tomas 6/25/2020 13:07'!
initialize
	ataques := OrderedCollection new! !


!Pokemon methodsFor: 'as yet unclassified' stamp: 'tomas 6/25/2020 13:12'!
atacarCon: unNombreAtaque a: otroPokemon
	| ataque |
	ataque := ataques detect: [ :nombreAtaque | nombreAtaque = unNombreAtaque ] ifNone: [ nil ].
	ataque isNil
		ifTrue: [ Transcript show: 'El pokemon ', nombre, ' no entiende el ataque ', unNombreAtaque, '.'; cr ]
		ifFalse: [ 
			ataque = 'ImpacTrueno'
				ifTrue: [ otroPokemon puntos: (otroPokemon puntos - 10) ]
				ifFalse:	[ 
					ataque = 'Brasas'
						ifTrue: [ otroPokemon puntos: (otroPokemon puntos - 20) ]
						ifFalse: [ Transcript show: 'El pokemon ', nombre, ' no entiende el ataque ', unNombreAtaque, '.'; cr ]
				]
		]
	! !


!Pokemon methodsFor: 'accessing' stamp: 'tomas 6/25/2020 13:06'!
puntos: unosPuntos
	puntos := unosPuntos! !


!Pokemon methodsFor: 'accessor' stamp: 'tomas 6/25/2020 12:54'!
puntos
	^ puntos! !

!Pokemon methodsFor: 'accessor' stamp: 'tomas 6/25/2020 13:06'!
nombre
	^ nombre! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Pokemon class
	instanceVariableNames: ''!

!Pokemon class methodsFor: 'as yet unclassified' stamp: 'tomas 6/25/2020 12:53'!
conNombre: unNombre
	| pokemon |
	pokemon := self new.
	pokemon nombre: unNombre.
	^ pokemon! !
